/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef CLIENTCALL_H_
#define CLIENTCALL_H_

#include <map>	
#include <string>
#include <iostream>
#include "ServiceClient.h"
#include "ClientContext.h"

using namespace std;

class ClientCall
{
	public:
		ClientCall();
		~ClientCall();
		
		void init(ClientContext *ctx);
		bool sendReceive(string pubTopic, string subTopic, char* data,int size_of_data,int noOfResponse,char** responses,int *numReturn);
		void send(string pubTopic, char* data);
		void close() ;
	
	private:
		ServiceClient serviceClient;
		//ServiceClient subServiceClient;
		

};


#endif /*CLIENTCALL_H_*/
