#include <iostream>
#include <string>
#include <map>

using namespace std;

#define NB_BROKER_HOST "156.56.104.15"
#define NB_BROKER_PORT 5045
#define NB_ENTITY_ID 6582
#define NB_TEMPLATE_ID 8899
#define DEMO_TOPIC "/clarens/nb/demo/topic"

Int_t FALSE = 0;
Int_t TRUE = 1;

class SimpleTest{
	RQ_OBJECT("SimpleTest")
	
	private:
		void *tc;
		void *tbk;
	
	public:
	    SimpleTest();
	    virtual ~SimpleTest();
	    void Init();
	    void Callback(void **v,char *bytes,int length);
	    void HandleMessages();
};

SimpleTest::SimpleTest(){	
};

SimpleTest::~SimpleTest(){
	delete tc;
	delete tbk;	
}

SimpleTest::Init(){
	tc=new TServiceClient();
	((TServiceClient *)tc)->Init(NB_BROKER_HOST,NB_BROKER_PORT,NB_ENTITY_ID,NB_TEMPLATE_ID);
	tbk=new TCallback();	
};


void
SimpleTest::Callback(void **v,char *bytes,int length){
	string *str=(string *)v[0];
	cout<<"The message says :"<<*str<<endl;
};

void
SimpleTest::HandleMessages(){
  string *str=new string("Hello");	
  void *args[10];
  args[0]=(void *)str;
  
  ((TCallback *)tbk)->registerCallback(args,"SimpleTest","Callback");
  ((TServiceClient *)tc)->Subscribe(DEMO_TOPIC,tbk);

  int in;
  cin>>in;

};

TestPubSub(){

	gDebug = kTRUE;  
	gSystem->Load("libnbclarens.so"); 
	
	SimpleTest st;	
	st.Init();
	st.HandleMessages();
	 	
}

