/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include <fstream>
#include "ServiceClient.h"
#include "Profile.h"
#include "unistd.h"

using namespace std;

static int TIME_LOOP_BUFF=500;

int main(int argc, char **argv){
	//cout<<"///////////////////////BMSender////////////////////////"<<endl;
	
	//long long ln=Utils::getCurrentTimeMicroseconds();
	//cout<<"Time Value = "<<ln<<endl;
	//int in=1234;
	//long long offset=0;
	//char buff[32];
	
	//Utils::writeInt(buff+offset,in,offset);
	//int it=Utils::readInt(buff,offset);
	//cout<<it<<endl;
	
	//Utils::writeLong(buff+offset,ln,offset);		
	//long long lt=Utils::readLong(buff,offset);
	//cout<<lt<<endl;
	
	if(argc!=8){
		cout<<"Usage : [host][port][entityId][topic][msgcount][sleepms][msgsize]"<<endl;
		exit(1);	
	}
	//Ignore the first argument 
	*argv++;	
	string host=*argv++;
	int port=5045;
	std::istringstream ss_port(*argv++);
	ss_port >> port;	
	
	int entityId=0;
	std::istringstream ss(*argv++);
    ss >> entityId;
	string contentSynopsis=*argv++;
	
	int msgcount=0;
	std::istringstream ss_msgcount(*argv++);
	ss_msgcount >> msgcount;
	
	int sleepms=0;
	std::istringstream ss_sleepms(*argv++);
	ss_sleepms >> sleepms;
	
	int msgsize=0;
	std::istringstream ss_msgsize(*argv++);
	ss_msgsize >> msgsize;
	
	if(entityId<=0|| contentSynopsis.length()<=0){
		cout<<"Usage : [host][port][entityId][topic][msgcount][sleepms][msgsize]"<<endl;
		exit(1);	
	}
	
	
	stringstream outFileName;
	outFileName<<"NB_Client_CPP_";
	outFileName<<msgsize;
	outFileName<<"_";
	outFileName<<msgcount;
	outFileName<<"_";
	outFileName<<sleepms;
	outFileName<<".txt";
	
	//ofstream outFile;
	//outFile.open (outFileName.str().c_str(), ios::out);
		
	
	int templateId=55745;
		
	ServiceClient serviceClient;
	serviceClient.init(host,port,entityId,templateId);
	
	//cout<<"====================Benchmark Sender==============="<<endl;
	//cout<<"Type any number of messages and <return key>"<<endl;
	//cout<<"To exit type .<return key>"<<endl;
	//cout<<"==================================================="<<endl;
	
	char msgbuff[msgsize];	
	for (int i=0;i<msgsize;i++){
		msgbuff[i]='A';
	}
	//cout<<msg<<endl;
	
	
	int sleeptime=sleepms*1000; //we need microseconds for usleep.
	
	//char buff[100+msgsize];
	long long offset;
	long long time=0;
	
	long long times[100];
	//Make the initials values to zero.
	for(int i=0;i<100;i++){
		times[i]=0;
	}
	
	
	int tempcount=0;
	int index=0;
	
	long long timeForTest=0;
	
	for(int i=0;i<msgcount;i++){
		index++;
		offset=0;
		time=Utils::getCurrentTimeMicroseconds();
		Utils::writeLong(msgbuff+offset,time,offset);
		long long beginTime=Utils::getCurrentTimeMicroseconds();
		serviceClient.publish(contentSynopsis,msgbuff,msgsize);	
		long long endTime=Utils::getCurrentTimeMicroseconds();
		timeForTest=endTime-beginTime;
		cout<<timeForTest<<endl;	
		//outFile <<timeForTest<<"\n";
		if(index%TIME_LOOP_BUFF==0){
			times[tempcount]+=timeForTest;
			tempcount++;
		}else{
			times[tempcount]+=timeForTest;
		}		
		usleep(sleeptime);
	}
	
	//outFile.close();
	
	cout<<"Time for the tests in  micros"<<endl;
	cout<<"Index = "<<index<<"  tempcount = "<<tempcount<<endl;	
	for(int i=0;i<tempcount;i++){				
		cout<<times[i]<<endl;				
	}
	
	sleep(1);
	
	serviceClient.cleanup();	
}
