/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <string>
#include <iostream>

#include "AgentServiceClient.h"
#include "ServiceException.h"
#include "AgentDiscoveryResponse.h"
#include <vector>
#include "SecurityUtil.h"

#include "openssl/aes.h"


using namespace std;


int main(){		
			
		string configFile="/home/jaliya/projects/cppworkspace/nbcpp/config/client_config.txt";
		//string configFile="/home/jaliya/projects/clarens/cpp/config/client_config.txt";
		
		AgentServiceClient serviceClient(configFile);
		
		
		try{
			serviceClient.init();
			int i=0;
			//for(;;){
				i++;
				try{
					cout<<"cycle ======================== "<<i<<"==============="<<endl;
					AgentDiscoveryResponse *discoveryResponse=serviceClient.discoverAgentFIFO();			
					cout<<"Discoverd an agent with agent ID = "<<discoveryResponse->getAgentId()<<endl;
					
					vector<string> serviceDescriptions=serviceClient.discoverServices(discoveryResponse);						
					for( vector<string>::iterator iter = serviceDescriptions.begin(); iter != serviceDescriptions.end(); iter++) {
	   					cout<<*iter<<endl;
 					}
					
							
					delete discoveryResponse;
					
				}catch(ServiceException& e){
					cout<<e.getMessage()<<endl;
				}			
				usleep(100000);
			//}			
		
		}catch (ServiceException& e){
			cout<<e.getMessage();
		}
	

		
		/*
		try{
		clientService.init();
		
		AgentDiscoveryResponse agentInfo=clientService.discoverAgent();
		System.out.println("Agent ID = "+agentInfo.getAgentId());
		

		RootletDiscoveryResponseMessage serviceInfo=clientService.discoverService(agentInfo);
		
		for(Iterator<String> i=   serviceInfo.getServices().keySet().iterator();i.hasNext();){
			System.out.println(i.next());
		}
		
		}catch(ClarensException e){
			e.printStackTrace();
			clientService.close();
		}
		
		clientService.close();
		
		*/
		
		cout<<"Agent Discoverd Now Closing"<<endl;
}
