/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <pthread.h>
#include <iostream>

using namespace std;
	
class Thread
{
   public:
      Thread();
      int Start(void * arg);
    void join();
   protected:
      int Run(void * arg);
      static void * EntryPoint(void*);
      virtual void Setup();
      virtual void Execute(void*);
      void * Arg() const {return Arg_;}
      void Arg(void* a){Arg_ = a;}
	  
	  
   private:
      //THREADID ThreadId_;
     pthread_t thread1;
      void * Arg_;

};

class Worker:public Thread
	{
			public:
				void init(int n);
				virtual void Execute(void*);
			private :
				int num;
				
	};
	
	

void Worker::init(int n)
	{
		this->num=n;
	}
	
void Worker::Execute(void* arg)
{
	//int *num=(int*)arg;
        // Your code goes here
	for(int i=0;i<10;i++)
	{
		
		cout<<num<<" ";	
			
	}
}



Thread::Thread() {}

int Thread::Start(void * arg)
{
   Arg(arg); // store user data
  int code= pthread_create( &thread1, NULL, Thread::EntryPoint,(void *)Arg_);
   //int code = thread_create(Thread::EntryPoint, this, & ThreadId_);
   return code;
}

int Thread::Run(void * arg)
{
	 Thread * pt = (Thread*)arg;
     pt->Setup();
      pt->Execute( arg );
}

/*static */
void * Thread::EntryPoint(void * pthis)
{
   Thread * pt = (Thread*)pthis;
   pt->Run( pt->Arg() );
}

void Thread::Setup()
{
        // Do any setup here
}


void Thread::Execute(void* arg)
{	
	//override
}



void Thread::join()
{
	cout<<"Coming to JOIN "<<endl;
	pthread_join( thread1, NULL);
}

int main(){
	cout<<"Testing "<<endl;	
	
	Worker th1;
	Worker th2;
	Worker th3;
	Worker th4;
	
	th1.init(1);
	th2.init(2);
	th3.init(3);
	th4.init(4);
	
	th1.Start((void *)&th1);
	th2.Start((void *)&th2);
	th3.Start((void *)&th3);
	th4.Start((void *)&th4);
	
	th1.join();
	th2.join();
	th3.join();
	th4.join();
	
}
